//+------------------------------------------------------------------+ 
//|                                  TrendStrength jurik channel.mq4 | 
//|                                                                  | 
//|                                         http://www.forextsd.com  |
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2010, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window 
#property indicator_buffers    4 
#property indicator_color1     DarkOrange
#property indicator_width1     2
#property indicator_color2     White
#property indicator_style2     STYLE_DASH
#property indicator_color3     Red
#property indicator_width3     1
#property indicator_color4     LimeGreen
#property indicator_width4     1
#property indicator_level1     0
#property indicator_levelcolor Violet

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    Price            = 0;
extern int    OmaLength        = 2;
extern double OmaSpeed         = 8.0;
extern bool   OmaAdaptive      = true;
extern int    HighLowPeriod    = 30;
extern bool   ShowChannel      = true;
extern bool   ShowZigZag       = true;
extern bool   Interpolate      = true;

extern string _                = "alerts settings";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

extern string  __              = "arrows settings";
extern bool   ShowArrows       = true;
extern string arrowsIdentifier = "oma trendstrength arrows1";
extern color  arrowsUpColor    = Lime;
extern color  arrowsDnColor    = Orange;


//
//
//
//
//

double ts[];
double zz[];
double hb[];
double lb[];
double zzlow[];
double zzhigh[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//
//
//
//
//

int init() 
{ 
   IndicatorBuffers(7);  
     SetIndexBuffer(0,ts); SetIndexLabel(0,"TS"); 
     SetIndexBuffer(1,zz); SetIndexLabel(1, NULL);  SetIndexStyle(1,DRAW_SECTION);       
     SetIndexBuffer(2,hb);
     SetIndexBuffer(3,lb);
     SetIndexBuffer(4,zzlow);
     SetIndexBuffer(5,zzhigh);
     SetIndexBuffer(6,trend);
   
     SetIndexEmptyValue(0,0);
     SetIndexEmptyValue(1,0);
     SetIndexEmptyValue(4,0);
     SetIndexEmptyValue(5,0);
   
     if (ShowChannel)
     {
     SetIndexStyle(2,DRAW_LINE);
     SetIndexStyle(3,DRAW_LINE);
     }
     else      
     {
     SetIndexStyle(2,DRAW_NONE);
     SetIndexStyle(3,DRAW_NONE);
     }
   
     //
     //
     //
     //
     //
   
       OmaSpeed          = MathMax(OmaSpeed,-1.5);
       OmaLength         = MathMax(OmaLength,1);
       indicatorFileName = WindowExpertName();
       calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
       returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
       timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame)+" Oma TrendStrength channel"); 
return(0);
} 

//
//
//
//
//

int deinit()
{  
   if (!calculateValue && ShowArrows) deleteArrows();  
return(0); 
} 

//
//
//
//
//

int start() 
{  
   int counted_bars=IndicatorCounted();
   int lastZag;
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1); 
          if (returnBars) { ts[0] = MathMin(limit+1,Bars-1); return(0); }
         
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {     
       if (ShowZigZag)
       for (lastZag=limit+1; lastZag<Bars; lastZag++) if (zzlow[lastZag] != 0 || zzhigh[lastZag] != 0) break;
       for (i=limit;i>=0; i--)
       {
              double       tmp = iMA(NULL,0, 5,0, MODE_EMA,PRICE_CLOSE,i);     
              double ma1 = tmp - iMA(NULL,0,10,0,MODE_SMMA,PRICE_CLOSE,i); 
              double ma2 = tmp - iMA(NULL,0,20,0,MODE_SMMA,PRICE_CLOSE,i); 
              double ma3 = tmp - iMA(NULL,0,30,0,MODE_SMMA,PRICE_CLOSE,i); 
              double ma4 = tmp - iMA(NULL,0,40,0,MODE_SMMA,PRICE_CLOSE,i);  
              double ma5 = tmp - iMA(NULL,0,50,0,MODE_SMMA,PRICE_CLOSE,i);
              double ma6 = tmp - iMA(NULL,0,60,0,MODE_SMMA,PRICE_CLOSE,i);
              double ma7 = tmp - iMA(NULL,0,70,0,MODE_SMMA,PRICE_CLOSE,i);
              double ma8 = tmp - iMA(NULL,0,80,0,MODE_SMMA,PRICE_CLOSE,i);
              double ma9 = tmp - iMA(NULL,0,90,0,MODE_SMMA,PRICE_CLOSE,i);         
         
              ts[i] = iOma((ma1+ma2+ma3+ma4+ma5+ma6+ma7+ma8+ma9)/9,OmaLength,OmaSpeed,OmaAdaptive,i);
              lb[i] = ts[ArrayMinimum(ts,HighLowPeriod,i)];
              hb[i] = ts[ArrayMaximum(ts,HighLowPeriod,i)];
          
              //
              //
              //
              //
              //
   
              trend[i] = trend[i+1];
              if (ts[i] > lb[i] && ts[i+1] <= lb[i+1]) trend[i] =  1;  
              if (ts[i] < hb[i] && ts[i+1] >= hb[i+1]) trend[i] = -1;
              manageArrow(i);
              
   //
   //
   //
   //
   //
   
   if (!ShowZigZag) continue;
      
              zzlow[i]  = 0;
              zzhigh[i] = 0;
              
              if (lb[i] < lb[i+1])
              {
                  if (zz[lastZag] == lb[lastZag])
                      zz[lastZag] =  0;
                      zz[i]       =  lb[i];
                      zzlow[i]    =  lb[i];
                          lastZag =  i;
                          continue;
              }
              
              if (hb[i] > hb[i+1])
              {
                  if (zz[lastZag] == hb[lastZag])
                      zz[lastZag] =  0;
                      zz[i]       =  hb[i];
                      zzhigh[i]   =  hb[i];
                          lastZag =  i;
                          continue;
              }
              
              if (zz[i] != 0)
              {
                  zz[i] = 0;
                  for (lastZag=i+1; lastZag<Bars; lastZag++)
                  {
                     if (zzlow[lastZag]  != 0) { zz[lastZag] = zzlow[lastZag];  break; }
                     if (zzhigh[lastZag] != 0) { zz[lastZag] = zzhigh[lastZag]; break; }
                  }
                  
              }
    
          } 
          manageAlerts();  
    return(0); 
    }
    
    //
    //
    //
    //
    //
    
    limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    if (ShowZigZag)
    for (lastZag=limit+1; lastZag<Bars; lastZag++) if (zzlow[lastZag] != 0 || zzhigh[lastZag] != 0) break;
    for (i=limit;i>=0; i--)
    {
        int y = iBarShift(NULL,timeFrame,Time[i]);
            ts[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,0,y);
            zz[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,1,y);
            hb[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,2,y);
            lb[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,3,y);
            zzlow[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,4,y);
            zzhigh[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,5,y);
            trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,6,y);
            manageArrow(i); 
            
            //
            //
            //
            //
            //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  ts[i+k] = ts[i] + (ts[i+n] - ts[i]) * k/n;
                  hb[i+k] = hb[i] + (hb[i+n] - hb[i]) * k/n;
                  lb[i+k] = lb[i] + (lb[i+n] - lb[i]) * k/n;
               
               }  	            
   }
   manageAlerts();
return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workOma[][7];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int s=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; s *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +s] = 0;
                              workOma[r][prc+s] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+s];  double f02=workOma[r-1][F02+s];
   double f03=workOma[r-1][F03+s];  double f04=workOma[r-1][F04+s];
   double f05=workOma[r-1][F05+s];  double f06=workOma[r-1][F06+s];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double signal    = MathAbs((price-workOma[r-endPeriod][prc+s]));
         double noise     = 0.00000000001;

            for(i=1; i<endPeriod; i++) noise=noise+MathAbs(price-workOma[r-i][prc+s]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+s] = f01;  workOma[r][F02+s] = f02;
   workOma[r][F03+s] = f03;  workOma[r][F04+s] = f04;
   workOma[r][F05+s] = f05;  workOma[r][F06+s] = f06;
   workOma[r][prc+s] = price;
   return(v03);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (!calculateValue && ShowArrows)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,221,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,222,true );
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 2.0*iATR(NULL,0,20,i)/4.0;//3.0*
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Oma TrendStrength trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Oma TrendStrength channel "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

